
// compile: g++ -o template_specialization.ex template_specialization.cpp

#include <iostream>

using namespace std;

// class template
template <typename T> class count {
  private:
    T value;
  public:
    count() { value=0; }
    void increase();
    T get();
  };
  
// class template specialization
template <> class count<char> {
  private:
    char value;
  public:
    count() { value='a'; }
    void increase();
    char get();
  };

void count<char>::increase() { value+=1; }
char count<char>::get() { return value; }
  
template <typename T> void count<T>::increase() { value+=1; }
template <typename T> T count<T>::get() { return value; }
  
  
int main()
  {

  count<int> x;  
  count<char> c;  
  
  for(int i=0;i<5;i++) {
    cout << x.get() << " " << c.get() << endl;
    x.increase(); c.increase();
    }
  
  return 0;
  }
  
