
// compile: g++ -o virtual.ex virtual.cpp

#include <iostream>
using namespace std;

class polygon {
  
  protected:
    double width, height;
    
  public:
    void set(double a, double b) { width=a; height=b; }
    virtual double area() { return (0.0); }
    
  };
  
  
class rectangle : public polygon {
  
  public:
    double area () { return (width*height); }
    
  };
  
  
class triangle : public polygon {
  
  public:
    double area () { return (width*height/2); }
    
  };


int main()
  {
    
  rectangle rect;
  triangle trgl;
  
  polygon *ppoly1=&rect; // points to an object of class polygon
                         // and is referenced to rect
  polygon *ppoly2=&trgl;
  
  ppoly1->set(4.0,5.0);
  ppoly2->set(4.0,5.0);
  
  cout << rect.area() << endl; // --> 20.0
  cout << trgl.area() << endl; // --> 10.0
    
  cout << ppoly1->area() << endl; // --> 20.0
  
  polygon poly;
  polygon *ppoly3=&poly;
  cout << ppoly3->area() << endl; // --> 0.0   
  }
  