// compile: mpic++ -o mpi1.ex mpi1.cpp
// run: time mpirun -np 2 ./mpi1.ex

#include <mpi.h>

#include <iostream>
using namespace std;

int main(int argc, char *argv[])
  {
  int i, j, sum=0;
  int rank, nranks;
 
  MPI_Init(&argc, &argv); // MPI initialization
  MPI_Comm_rank(MPI_COMM_WORLD, &rank); // get current process id
  MPI_Comm_size(MPI_COMM_WORLD, &nranks); // get number of processes
  
  cout << "Hello world from process "
       << rank+1 << " of " << nranks << "!" << endl;
       
  for(i=0;i<1000000;i++) for(j=0;j<10000;j++) sum+=(i+j)%2;
  cout << sum << endl;
  
  MPI_Finalize(); // MPI deinitialization
  
  return 0;
  }