
// compile: g++ -fopenmp -o omp2.ex omp2.cpp
// run: export OMP_NUM_THREADS=2; time ./omp2.ex

#include <omp.h>

#include <iostream>
#include <cmath>
using namespace std;

int main()
  {
  int i;
  double w;
  
  double sum=0.0;
  
  #pragma omp parallel for private(w) reduction(+:sum)
  for(i=0;i<50000000;i++) {
    w=sqrt((double)i);
    sum=sum+cos(w);
    }

  cout << sum << endl;
  
  return 0;
  }
  