
// compile: g++ -o inline.ex inline.cpp

// generate binary: g++ -S inline.cpp
//                  cat inline.s | grep call
// compare with and without compiler optimization "-O1"
// --> call    _Z3maxdd

// generate gdb code: g++ -g -o inline.ex inline.cpp
//                    gdb inline.ex
//                    (gdb) disas main
//                    (gdb) quit
// compare with and without compiler optimization "-O1"

#include <iostream>
#include <cstdlib>

using namespace std;

inline double max(double a, double b) {
  if (a>b) return a;
  else return b;
  }
  
/*
double max_inline(double a, double b) {
  if (a>b) return a;
  else return b;
  }
*/

int main()
  {
  double a, b, value;

  for(int i=0;i<10;i++) {
    a=((double)rand())/((double)RAND_MAX);
    b=((double)rand())/((double)RAND_MAX);
    value=max(a,b);
    cout << value << endl;
    }

  return 0;
  }
  
